{% extends "base.html" %}
{% load static %}
{% load djmoney %}
{% load article %}

{% block stylesheet %}
    <link rel="stylesheet" href="{% static 'css/couleurs_demande_article.css' %}">

    <!-- CSS pour datetime picker -->
    <link rel="stylesheet" href="{% static 'js/jquery.datetimepicker.min.css' %}">

    <!-- CSS pour autocomplete_light -->
    <!-- link rel="stylesheet" href="{% static 'autocomplete_light/vendor/select2/dist/css/select2.css' %}" -->
    <link rel="stylesheet" href="{% static 'select2/css/select2.css' %}">
    <link rel="stylesheet" href="{% static 'autocomplete_light/select2.css' %}">

    <!-- Bordure des tables -->
    <link rel="stylesheet" href="{% static 'css/table.css' %}">
{% endblock  %}


{% block javascript %}

    {# a employer dans les templates fils->{{ block.super }} #}
    {{ block.super }}

    <!-- datetime picker jQuery script -->
    <script src="{% static 'js/jquery.datetimepicker.full.js' %}"></script>

    <!-- Javascript for autocomplete_light -->
    <!-- Code Javascript de la bibliothèque 'select2' https://github.com/select2/select2 -->
    {% comment %}
        select2 est utilisée par django-autocomplete-light
    {% endcomment %}
    {# <script src="{% static 'select2/js/select2.min.js' %}"></script> #}
    {# il faut etre en full sinon ca ne s'affiche pas #}
    <script src="{% static 'select2/js/select2.full.js' %}"></script>

    <script src="{% static 'autocomplete_light/jquery.init.js' %}"></script>
    <script src="{% static 'autocomplete_light/autocomplete.init.js' %}"></script>
    <script src="{% static 'select2/js/select2.full.js' %}"></script>
    <script src="{% static 'autocomplete_light/forward.js' %}"></script>
    <script src="{% static 'autocomplete_light/select2.js' %}"></script>


{% endblock javascript %}



{% block extra_js %}
{# Code composé de Javascript et de Django Template Language #}
{# ========================================================= #}

<script type="text/javascript">

{% comment %}
https://learn.jquery.com/using-jquery-core/document-ready/

Experienced developers sometimes use the shorthand $() for $( document ).ready().
If you are writing code that people who aren't experienced with jQuery may see,
it's best to use the long form.

{% endcomment %}

$(document).ready(function() {

    // langue française pour les datetime pickers
    $.datetimepicker.setLocale('fr');

    {% for form_achat in formset_achats %}

        // Selection d'un article remplace par "dal"
        // $('#id_achatservice_related-{{ forloop.counter0 }}-projet').select2();

        // Selection d'un article remplace par "dal"
        // $('#id_achatservice_related-{{ forloop.counter0 }}-article').select2();

        {# Choix de la livraison souhaitée #}
        $('#id_achatservice_related-{{ forloop.counter0 }}-date_butoir').datetimepicker(
            {
                // http://marcocecchetti.it/Post/Articolo/608
                weeks: true,
                rtl: false,
                // formatTime:'H:i',
                // formatDate:'d/m/Y',
                format: 'd/m/Y H:i',
                // date
                datepicker: true,
                opened: false,
                todayButton: true,     // Show button "Go To Today"
                defaultSelect:  true,  // Highlight the current date even if the input is empty
                dayOfWeekStart : 1, // Start week DatePicker. Default Sunday=0.
                defaultDate: false,
                // https://secure.php.net/manual/fr/function.date.php
                minDate:0,    // today
                weekends : [],
                disabledDates : [],
                // time
                timepicker:true,
                timepickerScrollbar:true,
                step: 60,
                defaultTime:'10:00',
                allowTimes:[
                  '8:00', '9:00', '10:00', '11:00', '12:00',
                  '13:00', '14:00', '15:00', '16:00', '17:00',
                  '18:00', '19:00'
                ]
            }
        );

    {% endfor %}

});

</script>
{% endblock extra_js %}


{% block content %}


<a class="btn btn-success" href="{% url 'articles:demande_article_non_cloturee_list' %}">Liste des demandes non clôturées</a>
<a class="btn btn-success" href="{% url 'articles:demande_article_list' %}">Liste de toutes les demandes</a>


{% url 'articles:demande_achat_service_update' demande_article.pk  as url_demande_achat_service_update %}


{# https://getbootstrap.com/components/#labels #}

{% if demande_article.demande_non_transmise %}
<h4 class="couleur_demande_non_transmise">
{% elif demande_article.demande_transmise %}
<h4 class="couleur_demande_transmise">
{% elif demande_article.demande_en_cours %}
<h4 class="couleur_demande_en_cours">
{% elif demande_article.demande_traitee %}
<h4 class="couleur_demande_traitee">
{% elif demande_article.demande_cloturee %}
<h4 class="couleur_demande_cloturee">
{% endif %}
    <a href="{{ url_demande_achat_service_update }}">
        Demande N°{{ demande_article.id }}
    </a>
    {{ demande_article.get_description_without_crlf}}
</h4>


{% if messages %}
    <ul class="messages">
        {% comment %} https://getbootstrap.com/components/#alerts {% endcomment %}
        {% for message in messages %}
        <!--li{% if message.tags %} class="{{ message.tags }}"{% endif %} -->
            {% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
                <div class="alert alert-danger" role="alert">{{ message }}</div>
            {% elif message.level == DEFAULT_MESSAGE_LEVELS.SUCCESS %}
                <div class="alert alert-success" role="alert">{{ message }}</div>
            {% else %}
                <div class="alert alert-info" role="alert">{{ message }}</div>
            {% endif %}
        <!-- /li -->
        {% endfor %}
    </ul>
{% endif %}

{% url 'tiers:create'  as url_tiers_create %}

<form id="articles_achats" method="post" action=".">
    {% csrf_token %}
    <input type="hidden" name="demande_article" value="{{ demande_article }}">
    <div class="table-responsive">
        <table id="id_list_table" class="table table-condensed">
            <thead>
            <tbody>
                {{ formset_achats.management_form }}
                {# rajout des erreurs #}
                {% if formset_achats.errors %}
                    {% for error in formset_achats.non_field_errors %}
                        <div class="alert alert-error">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                {# Parcours des formulaires et des instances initiales associées #}
                {% for form_achat, achat_service in formset_instances %}
                    {{ form_achat.id }}
                    <tr>
                       <td>
                           <table id="id_table_in_table" class="table table-hover table-condensed
                                {% if forloop.counter|divisibleby:"2" %}
                                   table-pair
                                {% else %}
                                    table-impair
                                {% endif %}
                               ">
                               {# un element de formulaire => un tableau dans un tableau #}
                                <tbody>
                                    <tr>
                                        {% url 'articles:achat_service_delete' form_achat.id.value  as url_achat_service_delete %}
                                        {% url 'articles:achat_service_clone' form_achat.id.value  as url_achat_service_clone %}
                                        {% if forloop.counter <= nb_articles %}
                                            <td colspan=2 id={{ forloop.counter }}>
                                               {% for num_article in list_articles %}
                                                  {% if num_article != forloop.parentloop.counter  %}
                                                      <a href="#{{ num_article }}">Achat {{ num_article }}</a>
                                                  {% else %}
                                                      Achat {{ forloop.parentloop.counter }} N°{{achat_service.id }}
                                                  {% endif %}
                                               {% endfor %}
                                               {% if demande_article.demande_non_cloturee %}
                                                   <a href="{{ url_achat_service_clone }}">| Ajouter un article</a>
                                                   <a href="{{ url_achat_service_delete }}">| Supprimer un article</a
                                                   {% if forloop.counter >= 2 %}
                                                        <ul class=list-group>
                                                          <li class="alert alert-success list-group-item">
                                                            <a href="{{ url_demande_achat_service_update }}">Demande article N°{{ demande_article.id }}</a>
                                                               {{ demande_article.get_description_without_crlf }}
                                                          </li>
                                                       </ul>
                                                   {% endif %}
                                               {% endif %}
                                            </td>
                                        {% else %}
                                            <td colspan=2>
                                            </td>
                                        {% endif %}
                                    </tr>
                                    {% if demande_article.reponse_affichable %}
                                        <tr>
                                            {% comment %} Affichage en vert quand l'état du poste est dans l'état "Traité" {% endcomment %}
                                            <td {% if achat_service.is_poste_traite %} class="text-right poste_traite" {% else %} class="text-right" {% endif %}>
                                                Etat du poste {{ form_achat.etat_poste }}
                                            </td>
                                            <td {% if achat_service.is_poste_traite %} {% else %} class="info" {% endif %}>
                                                Réponse {{ form_achat.reponse }}
                                            </td>
                                        </tr>
                                        {% if achat_service.demande_cloturee_and_no_responses %}
                                        {% else %}
                                            <tr>
                                                {% url 'articles:achat_service_reponse_list'  achat_service.id  as url_list_reponses %}
                                                <td class="text-right">
                                                    {% if demande_article.demande_non_cloturee %}
                                                        <a href="{{ url_list_reponses }}">Documents réponse</a>
                                                    {% else %}
                                                        Documents réponse
                                                    {% endif %}
                                                </td>
                                                <td>
                                                    {% if forloop.counter <= nb_articles %}
                                                        {% for document in achat_service.responses.all %}
                                                            {% with media=document.item %}
                                                                {# https://getbootstrap.com/css/#tables-example #}
                                                                <p>{{ media.render }} </p>
                                                            {% endwith %}
                                                        {% endfor %}
                                                    {% endif %}
                                                </td>
                                            </tr>
                                        {% endif %}
                                    {% endif %}
                                    <tr>
                                        <td class="text-right">Code article</td>
                                        <td class="danger">
                                        {% if demande_article.demande_non_cloturee %}
                                            {{ form_achat.article }}
                                        {% endif %}
                                        {{ achat_service.get_libelle_article }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Projet</td>
                                        <td>
                                            {% if demande_article.demande_non_cloturee %}
                                                {{ form_achat.projet }}
                                            {% endif %}
                                            {{ achat_service.get_libelle_projet }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Description</td>
                                        <td>{{ form_achat.description }}</td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Prestataire</td>
                                        <td>
                                            {% if demande_article.demande_non_cloturee %}
                                                {{ form_achat.prestataire }}
                                                <a href="{{ url_tiers_create }}"> <img src="{% static "tiers/icon-addlink.svg" %}" alt="Ajouter"/> </a>
                                            {% endif %}
                                            {{ achat_service.get_libelle_prestataire }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Quantite</td>
                                        <td>{{ form_achat.quantite }} Prix {{ form_achat.prix_unitaire }} </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Livraison souhaitée</td>
                                        <td class="danger">{{ form_achat.date_butoir }}</td>
                                    </tr>
                                    {% if achat_service.demande_cloturee_and_no_documents %}
                                    {% else %}
                                        <tr>
                                            {% url 'articles:achat_service_doc_list'  achat_service.id  as url_list_documents %}
                                            <td class="text-right">
                                                {% if demande_article.demande_non_cloturee %}
                                                    {% if forloop.counter <= nb_articles %}
                                                        <a href="{{ url_list_documents }}">Documents associés</a>
                                                    {% endif %}
                                                {% else %}
                                                    Documents associés
                                                {% endif %}
                                            </td>
                                            <td>
                                                {% if forloop.counter <= nb_articles %}
                                                    {% for document in achat_service.contents.all %}
                                                        {% with media=document.item %}
                                                            <p>{{ media.render }} </p>
                                                        {% endwith %}
                                                    {% endfor %}
                                                {% endif %}
                                            </td>
                                        </tr>
                                    {% endif %}
                                    <tr>
                                        <td colspan=2>
                                            {% comment %}
                                              On n'affiche pas de bouton quand une demande est cloturée.
                                            {% endcomment %}
                                            {% if demande_article.demande_non_cloturee %}
                                                {% if forloop.counter <= nb_articles %}
                                                    <input type="submit" name="btn_form_fdt"  value="Mise à jour article achat service {{ forloop.counter }} N°{{ achat_service.id }}" class="btn btn-success btn-xs btn-block" />
                                                {% else %}
                                                    <input type="submit" name="btn_form_fdt"  value="Création article {{ forloop.counter }}" class="btn btn-danger btn-block" />
                                                {% endif %}
                                            {% endif %}
                                        </td>
                                    </tr>
                                </tbody>
                            {# table imbriquee #}
                            </table>
                       </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
</form>



{% endblock %}


{% block footer %}
{% endblock footer %}
